/** A wrapper class around java dll version of the Sapien DLL that
 *  allows to send commands to RoboSapien and other WowWee robots using
 *  LEGO serial IR tower or using RCX and any IR tower.
 */
public class SapienDLL {

    /** open serial port and setup. Returns handle to be passed to SapienSend, and SapienClose. */
	public static native long sapienOpen(String port);

	/** convert string representation of command to hex code value
	    (version: 1 for RoboSapien, 2 for RoboSapien V2, 3 for RoboPet) */
	public static native int sapienDecode(String sapienCmd, int version);

	/** send hex code value through serial port */
	public static native void sapienSend(long f, int b, int nowakeup);

	/** close serial port */
	public static native void sapienClose(long f);

	/** send hex code value relayed through ir tower and RCX (b can also be a 3-byte RCX command) */
	public static native void rcxSapienSend(long f, int b);

	/** open serial port for relaying through RCX, use tty=="usb" for USB ir tower */
    public static native long rcxSapienInit(String tty, int isFast);

    static { System.loadLibrary("sapienjava"); }

}
