// sapienjava.cpp : control Sapien and other WowWee bots from Java applications

#include <jni.h>
#include <windows.h>

#include "SapienDLL.h"
#include "../../sapien.h"

/*
BOOL APIENTRY DllMain( HANDLE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}
*/

JNIEXPORT void JNICALL Java_SapienDLL_SapienSend
  (JNIEnv *env, jclass cls, jlong f_jlong, jint b_jint, jint nowakeup_jint)
{
  sap_send((HANDLE)f_jlong, (int)nowakeup_jint, (int)b_jint);
}

JNIEXPORT jint JNICALL Java_SapienDLL_SapienDecode
  (JNIEnv *env, jclass cls, jstring cmd_jstring, jint version)
{
  const char *sapien_cmd = env->GetStringUTFChars(cmd_jstring, 0);
  int rv = sap_decode(sapien_cmd, (int)version);
  env->ReleaseStringUTFChars(cmd_jstring, sapien_cmd);
  return rv;
}

JNIEXPORT jlong JNICALL Java_SapienDLL_SapienOpen
  (JNIEnv *env, jclass cls, jstring port_JString)
{
  const char *port = env->GetStringUTFChars(port_JString, 0);
  HANDLE rv;
  rv = sap_open(port);
  env->ReleaseStringUTFChars(port_JString, port);
  return (jlong)rv;
}

JNIEXPORT void JNICALL Java_SapienDLL_SapienClose
  (JNIEnv *env, jclass cls, jlong f)
{
  sap_close((HANDLE)f);
}

/*
 * Class:     SapienDLL
 * Method:    rcxSapienSend
 * Signature: (JI)V
 */
JNIEXPORT void JNICALL Java_SapienDLL_rcxSapienSend
  (JNIEnv *env, jclass cls, jlong f_jlong, jint b_jint)
{
  rcx_sap_send((HANDLE)f_jlong, (int)b_jint);
}

/*
 * Class:     SapienDLL
 * Method:    rcxSapienInit
 * Signature: (Ljava/lang/String;I)J
 */
JNIEXPORT jlong JNICALL Java_SapienDLL_rcxSapienInit
  (JNIEnv *env, jclass cls, jstring port_JString, jint is_fast_jint)
{
  jlong rv;
  const char *port = env->GetStringUTFChars(port_JString, 0);
  rv = (jlong) rcx_init(port, (int)is_fast_jint);
  env->ReleaseStringUTFChars(port_JString, port);
  return rv;
}

