#ifdef SAPIENDLL_EXPORTS
#define SAPIENDLL_API __declspec(dllexport)
#else
#define SAPIENDLL_API __declspec(dllimport)
#endif

//usage:
// ...
//  sapien_open("COM1");  //open serial port
//  ...
//  sapien_send(0x350, 0); //send dance_demo command to Sapien version 2, and light up IR tower first
//  ...
//  sapien_send(sapien_decode("dance_demo", 2), 0);  //another way for doing the same
//  ...
//  sapien_close();  //close serial port

extern "C" {

//open serial port and setup
SAPIENDLL_API void sapien_open(char *port);

//convert string representation of command to hex code value 
//(version: 1 for RoboSapien, 2 for RoboSapien V2, 3 for RoboPet)
SAPIENDLL_API int sapien_decode(char *sapien_cmd, int version);

//send hex code value through serial port
SAPIENDLL_API void sapien_send(int b, int nowakeup);

//close serial port
SAPIENDLL_API void sapien_close();

//send hex code value relayed through ir tower and RCX (b can also be a 3-byte RCX command)
SAPIENDLL_API void rcx_sapien_send(int b);

//open serial port for relaying through RCX, use tty=="usb" for USB ir tower
SAPIENDLL_API void rcx_sapien_init(char *tty, int is_fast);

}
